/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/robots/mikrokopter-genom3/work/templates/ros/client/ros/mikrokopter/srv/set_imu_filter.srv
 *
 */


#ifndef MIKROKOPTER_MESSAGE_SET_IMU_FILTERREQUEST_H
#define MIKROKOPTER_MESSAGE_SET_IMU_FILTERREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <mikrokopter/mikrokopter_ids_imu_filter_s.h>

namespace mikrokopter
{
template <class ContainerAllocator>
struct set_imu_filterRequest_
{
  typedef set_imu_filterRequest_<ContainerAllocator> Type;

  set_imu_filterRequest_()
    : imu_filter()  {
    }
  set_imu_filterRequest_(const ContainerAllocator& _alloc)
    : imu_filter(_alloc)  {
    }



   typedef  ::mikrokopter::mikrokopter_ids_imu_filter_s_<ContainerAllocator>  _imu_filter_type;
  _imu_filter_type imu_filter;




  typedef boost::shared_ptr< ::mikrokopter::set_imu_filterRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::mikrokopter::set_imu_filterRequest_<ContainerAllocator> const> ConstPtr;

}; // struct set_imu_filterRequest_

typedef ::mikrokopter::set_imu_filterRequest_<std::allocator<void> > set_imu_filterRequest;

typedef boost::shared_ptr< ::mikrokopter::set_imu_filterRequest > set_imu_filterRequestPtr;
typedef boost::shared_ptr< ::mikrokopter::set_imu_filterRequest const> set_imu_filterRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::mikrokopter::set_imu_filterRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::mikrokopter::set_imu_filterRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace mikrokopter

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'mikrokopter': ['mikrokopter/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::mikrokopter::set_imu_filterRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::mikrokopter::set_imu_filterRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mikrokopter::set_imu_filterRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mikrokopter::set_imu_filterRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mikrokopter::set_imu_filterRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mikrokopter::set_imu_filterRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::mikrokopter::set_imu_filterRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "b2cdc304ef28f99b354457302e5819db";
  }

  static const char* value(const ::mikrokopter::set_imu_filterRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xb2cdc304ef28f99bULL;
  static const uint64_t static_value2 = 0x354457302e5819dbULL;
};

template<class ContainerAllocator>
struct DataType< ::mikrokopter::set_imu_filterRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "mikrokopter/set_imu_filterRequest";
  }

  static const char* value(const ::mikrokopter::set_imu_filterRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::mikrokopter::set_imu_filterRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
mikrokopter_ids_imu_filter_s imu_filter\n\
\n\
================================================================================\n\
MSG: mikrokopter/mikrokopter_ids_imu_filter_s\n\
# IDL struct ::mikrokopter::ids::imu_filter_s\n\
float64 gain\n\
float64 Q\n\
";
  }

  static const char* value(const ::mikrokopter::set_imu_filterRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::mikrokopter::set_imu_filterRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.imu_filter);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct set_imu_filterRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::mikrokopter::set_imu_filterRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::mikrokopter::set_imu_filterRequest_<ContainerAllocator>& v)
  {
    s << indent << "imu_filter: ";
    s << std::endl;
    Printer< ::mikrokopter::mikrokopter_ids_imu_filter_s_<ContainerAllocator> >::stream(s, indent + "  ", v.imu_filter);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MIKROKOPTER_MESSAGE_SET_IMU_FILTERREQUEST_H
